package sklep.rest;

import jakarta.ws.rs.*;
import sklep.db.DBConnection;
import sklep.db.DBException;
import sklep.db.ProductDAO;
import sklep.db.RecordNotFound;
import sklep.model.Product;

import java.util.List;

@Path("/products.html")
@Produces("text/html;charset=UTF-8")
public class RProductsHtml {
    @GET
    public String allProducts() throws DBException {
        try(DBConnection db = DBConnection.open()) {
            ProductDAO productDAO = db.productDAO();
            List<Product> products = productDAO.readAll();
            StringBuilder txt = new StringBuilder("<!DOCTYPE html>\n<html><body>\n");
            txt.append("<h1>Lista produktów</h1>\n");
            for(Product product : products) {
                txt.append(product.toHtml()).append('\n');
            }
            txt.append("</body></html>");
            return txt.toString();
        }
    }

    @GET
    @Path("/{id}")
    public String oneProduct(@PathParam("id") int productId) throws DBException, RecordNotFound {
        try(DBConnection db = DBConnection.open()) {
            ProductDAO productDAO = db.productDAO();
            Product product = productDAO.findById(productId);
            return "<!DOCTYPE html>\n<html><body>" + product.toHtml() + "</body></html>";
        }
    }
}
